package doctor.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.nacos.api.model.v2.Result;
import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import doctor.common.core.domain.HealthR;
import doctor.domain.entity.SickCircleEntity;
import doctor.service.CollectSickService;

import doctor.util.HttpUtils;
import doctor.util.OssUtil;
import org.apache.commons.codec.binary.Base64;
import org.apache.http.HttpResponse;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.security.MessageDigest;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName CollectSickController
 * @Description 描述
 * @Author 栗永斌
 */
@RestController
@RequestMapping("/user/verify/v1")
public class CollectSickController {
    @Autowired
    CollectSickService service;

    /**
     * 取消收藏病友圈
     *
     * @param sickCircleId
     * @return
     */
    @DeleteMapping("/cancelSickCollection")
    public HealthR<SickCircleEntity> cancelSickCollection(@RequestParam("sickCircleId") Integer sickCircleId) {
        return service.cancelSickCollection(sickCircleId);
    }

    /**
     * * @param sickCircleId
     * 收藏病友圈
     */
    @PostMapping("/addUserSickCollection")
    public HealthR<SickCircleEntity> addUserSickCollection(@RequestParam("sickCircleId") Integer sickCircleId) {
        return service.addUserSickCollection(sickCircleId);
    }

    //-----------------------------------------------------------------------------------------------------------------------------------------


    //-----------------------------------------------------------------------------------------------------------------------------------------
    /**
     *  orc身份证识别
     * @param file
     */
    @PostMapping("/files")
    public void file(MultipartFile file) {

        String s = OssUtil.uploadMultipartFile(file);

        String host = "https://cardnumber.market.alicloudapi.com";
        String path = "/rest/160601/ocr/ocr_idcard.json";
        String appcode = "94e0f9d0960f4931ad24eabfa187dcfe";
        //String imgFile = "C:\\Users\\栗永斌\\Desktop\\aaaa.webp";
        String imgFile = String.valueOf(s);
        String method = "POST";

        Map<String, String> headers = new HashMap<String, String>();
        //最后在header中的格式(中间是英文空格)为Authorization:APPCODE 83359fd73fe94948385f570e3c139105
        headers.put("Authorization", "APPCODE " + appcode);
        //根据API的要求，定义相对应的Content-Type
        headers.put("Content-Type", "application/json; charset=UTF-8");

        Map<String, String> querys = new HashMap<String, String>();
        // 对图像进行base64编码
        String imgBase64 = img_base64(imgFile);

        //configure配置
        JSONObject configObj = new JSONObject();
        configObj.put("side", "face");

        String config_str = configObj.toString();

        // 拼装请求body的json字符串
        JSONObject requestObj = new JSONObject();
        requestObj.put("image", imgBase64);
        if (configObj.size() > 0) {
            requestObj.put("configure", config_str);
        }
        String bodys = requestObj.toString();

        try {
            /**
             * 重要提示如下:
             * HttpUtils请从
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/src/main/java/com/aliyun/api/gateway/demo/util/HttpUtils.java
             * 下载
             * 相应的依赖请参照
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/pom.xml
             */
            HttpResponse response = HttpUtils.doPost(host, path, method, headers, querys, bodys);
            int stat = response.getStatusLine().getStatusCode();
            if (stat != 200) {
                System.out.println("Http code: " + stat);
                System.out.println("http header error msg: " + response.getFirstHeader("X-Ca-Error-Message"));
                System.out.println("Http body error msg:" + EntityUtils.toString(response.getEntity()));
                return;
            }

            String res = EntityUtils.toString(response.getEntity());
            JSONObject res_obj = JSON.parseObject(res);

            System.out.println(res_obj.toJSONString());
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public static String img_base64(String path) {
        /**
         *  对path进行判断，如果是本地文件就二进制读取并base64编码，如果是url,则返回
         */
        String imgBase64 = "";
        if (path.startsWith("http")) {
            imgBase64 = path;
        } else {
            try {
                File file = new File(path);
                byte[] content = new byte[(int) file.length()];
                FileInputStream finputstream = new FileInputStream(file);
                finputstream.read(content);
                finputstream.close();
                imgBase64 = new String(Base64.encodeBase64(content));
            } catch (IOException e) {
                e.printStackTrace();
                return imgBase64;
            }
        }
        return imgBase64;
    }



    private static final String AES_KEY = "1234567890123456";

    @PostMapping("file")
    public HealthR<String> hao(@RequestParam("file") String hao){
//        // 验证主机号长度
//        if (hao.length() != 32) {
//            HealthR.fail("主机号长度不合法，操作失败！");
//        }
//        // AES加密
//        String encryptedHostNumber = encryptAES(hao, AES_KEY);
//        // Base64编码
//        String base64Encoded = java.util.Base64.getEncoder().encodeToString(encryptedHostNumber.getBytes(StandardCharsets.UTF_8));
//        // MD5加密
//        String md5Hash = generateMD5Hash(base64Encoded);

        String s = OssUtil.uploadFile(hao);
// 生成二维码（这里省略生成二维码的步骤）
        try {
            // 二维码内容
            String qrCodeData =s;

            // 设置二维码的宽度和高度
            int width = 300;
            int height = 300;

            // 设置二维码图片保存路径
            String filePath = "C:\\Users\\栗永斌\\Desktop\\二维码.png";//自己的


            String endpoint="oss-cn-shanghai.aliyuncs.com";//自己的
            String accessKeyId="LTAI5tLE4XbyvvbuT7D2stCk";//自己的
            String accessKeySecret="W7ZeT4dMrMPP0c8BBwcyIPnhe3P4E8";//自己的
            OSS ossClient = new OSSClientBuilder().build(endpoint, accessKeyId, accessKeySecret);

            try {
                File file = new File(filePath);
                String objectName = "身份证"; // OSS 对象名称

                String bucketName="lyb1314";
                // 上传文件
                ossClient.putObject(bucketName, objectName, file);

                System.out.println("文件上传成功！");

                // 如果需要获取上传后的文件 URL，可以使用以下代码
                String fileUrl = "https://" + bucketName + "." + endpoint + "/" + objectName;
                System.out.println("文件访问地址：" + fileUrl);
            } finally {
                // 关闭 OSS 客户端
                ossClient.shutdown();
            }

            //   存储到数据库
//            saveToDatabase(hao, md5Hash,filePath);
//            System.out.println("操作成功！生成的序列号为：" + md5Hash);

            // 设置二维码图片格式
            String fileType = "png";

            // 创建 BitMatrix 对象
            BitMatrix bitMatrix = new QRCodeWriter().encode(qrCodeData, BarcodeFormat.QR_CODE, width, height);

            // 将 BitMatrix 转换为 BufferedImage
            Path path = Paths.get(filePath);
            CollectSickController.MatrixToImageWriter.writeToPath(bitMatrix, fileType, path);


        } catch (WriterException e) {
            throw new RuntimeException("生成二维码失败", e);
        }

        return  null;

    }



    public static class MatrixToImageWriter {
        private static final int BLACK = 0xFF000000;
        private static final int WHITE = 0xFFFFFFFF;

        private MatrixToImageWriter() {}

        public static void writeToPath(BitMatrix matrix, String format, Path path) {
            try {
                CollectSickController.MatrixToImageWriter.MatrixToImageConfig config = new CollectSickController.MatrixToImageWriter.MatrixToImageConfig(BLACK, WHITE);
                CollectSickController.MatrixToImageWriter.writeToPath(matrix, format, path, config);
            } catch (Exception e) {
                throw new RuntimeException("写入二维码图片失败", e);
            }
        }

        public static void writeToPath(BitMatrix matrix, String format, Path path, CollectSickController.MatrixToImageWriter.MatrixToImageConfig config) {
            try {
                BufferedImage image = toBufferedImage(matrix, config);
                if (!ImageIO.write(image, format, path.toFile())) {
                    throw new RuntimeException("写入二维码图片失败");
                }
            } catch (IOException e) {
                throw new RuntimeException("写入二维码图片失败", e);
            }
        }

        private static BufferedImage toBufferedImage(BitMatrix matrix, CollectSickController.MatrixToImageWriter.MatrixToImageConfig config) {
            int width = matrix.getWidth();
            int height = matrix.getHeight();
            BufferedImage image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
            for (int x = 0; x < width; x++) {
                for (int y = 0; y < height; y++) {
                    image.setRGB(x, y, matrix.get(x, y) ? config.getPixelOnColor() : config.getPixelOffColor());
                }
            }
            return image;
        }

        public static class MatrixToImageConfig {
            private final int onColor;
            private final int offColor;

            public MatrixToImageConfig(int onColor, int offColor) {
                this.onColor = onColor;
                this.offColor = offColor;
            }

            public int getPixelOnColor() {
                return onColor;
            }

            public int getPixelOffColor() {
                return offColor;
            }
        }
    }

    private static void saveToDatabase(String hostNumber, String serialNumber,String filePath) {
        try {
            // 假设你有一个数据库连接，并且有一个表用于存储主机号和序列号
            String jdbcUrl = "jdbc:mysql://101.34.77.101:3306/dome1";
            String username = "root";
            String password = "cbx@123";

            Connection connection = DriverManager.getConnection(jdbcUrl, username, password);

            // 插入数据
            String sql = "INSERT INTO `dome1`.`t_list` ( `host_number`, `serial_number`,`img`) VALUES (?, ?,?)";


            try (PreparedStatement preparedStatement = connection.prepareStatement(sql)) {
                preparedStatement.setString(1, hostNumber);
                preparedStatement.setString(2, serialNumber);
                preparedStatement.setString(3, filePath);
                preparedStatement.executeUpdate();

            }

            connection.close();
        } catch (Exception e) {
            throw new RuntimeException("存储到数据库失败", e);
        }
    }


    private static String encryptAES(String input, String key) {
        try {
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            SecretKeySpec secretKey = new SecretKeySpec(key.getBytes(StandardCharsets.UTF_8), "AES");
            cipher.init(Cipher.ENCRYPT_MODE, secretKey);
            return new String(cipher.doFinal(input.getBytes(StandardCharsets.UTF_8)), StandardCharsets.UTF_8);
        } catch (Exception e) {
            throw new RuntimeException("AES加密失败", e);
        }
    }

    private static String generateMD5Hash(String input) {
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            byte[] hashBytes = md.digest(input.getBytes(StandardCharsets.UTF_8));
            StringBuilder hexString = new StringBuilder();
            for (byte b : hashBytes) {
                String hex = Integer.toHexString(0xFF & b);
                if (hex.length() == 1) {
                    hexString.append('0');
                }
                hexString.append(hex);
            }
            return hexString.toString();
        } catch (Exception e) {
            throw new RuntimeException("MD5加密失败", e);
        }
    }

}
